structure Horn  =

struct

(* constraints *)

 
   datatype 'a ind  =	Const of 'a	|	Var of int
   datatype ('a,'b) pre = 	U of 'b * 'a ind list
	        |	N of 'b * 'a ind list
	 	|	FunApp of 'a ind * ('a list -> 'a) * 'a ind list 
		|	Eq of 'a ind * 'a ind
		|	Neq of 'a ind * 'a ind
		|	And of ('a,'b) pre * ('a,'b) pre
		|	Or of ('a,'b) pre * ('a,'b) pre
		|	Exists of int * ('a,'b) pre
		|	CheapOr of ('a,'b) pre * ('a,'b) pre
		|	CheapExists of int * ('a,'b) pre
		|	Yes | No
		
   datatype ('a,'b) clause = 	One
		|	R of 'b * 'a ind list
		|	Implies of ('a,'b) pre * ('a,'b) clause
	        |	Break of ('a,'b) clause
        	|	Both of ('a,'b) clause * ('a,'b) clause
		|	Forall of int * ('a,'b) clause

end

