structure IntSet = 

struct
   structure S = IntUtils
   type set = int list

   fun listToSet list = S.remDup list

   fun hasElement ([],_) = false
    |  hasElement (x::xs,y) = (case Int.compare (x,y) 
	of GREATER => false
	|  LESS	  => hasElement (xs,y)
	|  EQUAL  => true
	)

   fun super (_,[]) = true
    |  super ([],_) = false
    |  super (x::xs,y::ys) =  (case Int.compare (x,y)
        of GREATER => false
        |  LESS   => super (xs,y::ys)
        |  EQUAL  => super (xs,ys)
	)
end       
