structure LexTest =
   struct
      open Lexer LexBase

      fun genLexer fname = let val f = TextIO.openIn fname
			       val i = fn x => TextIO.inputN(f,x)
			   in (f,makeLexer i)
			   end

      fun testLexer fname =
	 let 
	    val (f,lexer) = genLexer fname
	    fun doit() = let val t = lexer()
			     val _ = print(Token2String t^"\n")
			 in case t
			      of T_EOF => TextIO.closeIn f
			       | _     => doit()
			 end
	 in doit()
	 end
   end
   