signature Clause_TOKENS =
sig
type ('a,'b) token
type svalue
val NAME: (string) *  'a * 'a -> (svalue,'a) token
val DOT:  'a * 'a -> (svalue,'a) token
val FORALL:  'a * 'a -> (svalue,'a) token
val EXISTS:  'a * 'a -> (svalue,'a) token
val NO:  'a * 'a -> (svalue,'a) token
val YES:  'a * 'a -> (svalue,'a) token
val NEQ:  'a * 'a -> (svalue,'a) token
val EQ:  'a * 'a -> (svalue,'a) token
val IMPLIES:  'a * 'a -> (svalue,'a) token
val OR:  'a * 'a -> (svalue,'a) token
val AND:  'a * 'a -> (svalue,'a) token
val NOT:  'a * 'a -> (svalue,'a) token
val COMMA:  'a * 'a -> (svalue,'a) token
val CLOSE:  'a * 'a -> (svalue,'a) token
val OPEN:  'a * 'a -> (svalue,'a) token
val CLOSESTRING:  'a * 'a -> (svalue,'a) token
val OPENSTRING:  'a * 'a -> (svalue,'a) token
val CLOSELIT:  'a * 'a -> (svalue,'a) token
val OPENLIT:  'a * 'a -> (svalue,'a) token
val CLOSEFORMULA:  'a * 'a -> (svalue,'a) token
val OPENFORMULA:  'a * 'a -> (svalue,'a) token
val COPY: (string) *  'a * 'a -> (svalue,'a) token
val EOF:  'a * 'a -> (svalue,'a) token
end
signature Clause_LRVALS=
sig
structure Tokens : Clause_TOKENS
structure ParserData:PARSER_DATA
sharing type ParserData.Token.token = Tokens.token
sharing type ParserData.svalue = Tokens.svalue
end
