signature ERRORMSG =
 sig
    structure Position : POSITION
    val error_flag : bool ref 
    val error      : Position.position -> string -> 'a 
    val error_ft   : Position.position * Position.position -> string -> 'a
    val warn       : Position.position -> string -> unit
    val abort      : string -> 'a
    val bug        : string * string -> 'a
    val init       : unit -> unit
    exception Syntax of string
    exception Bug    of string
    exception Error
 end
