signature ForestMap =

sig
   type 'a map

   
   val makeMap	:	int -> 'a map
   val nullMap 	:	unit -> 'a map
   val next	:	'a map * int * int -> bool * int
   val numberOfNodes : 	'a map -> int

   val sub 	:	'a map      * int * int list -> 'a option
   val update	:	'a map      * int * int list * 'a -> unit
   val add	:	'a list map * int * int list * 'a -> unit
end
