structure IntListItem =

struct
   type item = int list

   fun eq (l1,l2) = (l1 = l2)

   fun toString list = let
	fun doit [] = "]"
	 |  doit [x] = Int.toString x ^ "]"
	 |  doit (x::xs) = Int.toString x ^ ", " ^
			   doit xs			
	in "[" ^ doit list
	end

   fun toWord [] = 0wxd	
    |  toWord (x::xs) = (toWord xs) * 0wx7 + Word.fromInt x
end


