functor ItemListItem (structure Item : Item) : Item =

struct
   type item = Item.item list

   fun toString list = let
	fun doit [] = "]"
	 |  doit [x] = Item.toString x ^ "]"
	 |  doit (x::xs) = Item.toString x ^ ", " ^
			   doit xs			
	in "[" ^ doit list
	end

   fun toWord [] = 0wxd	
    |  toWord (x::xs) = (toWord xs) * 0wx7 + Item.toWord x
end

structure IntListItem = ItemListItem (structure Item = IntItem)
structure StringListItem = ItemListItem (structure Item = StringItem)

