functor ItemListItemEq (structure Item : ItemEq) =

struct
   type item = Item.item list

   fun toString list = let
	fun doit [] = "]"
	 |  doit [x] = Item.toString x ^ "]"
	 |  doit (x::xs) = Item.toString x ^ ", " ^
			   doit xs			
	in "[" ^ doit list
	end

   fun toWord [] = 0wxd	
    |  toWord (x::xs) = (toWord xs) * 0wx7 + Item.toWord x

   fun eq ([],[]) = true
    |  eq (x::xs,y::ys) = if Item.eq (x,y) then eq (xs,ys)
			  else false
    |  eq _ = false
end


