funsig Pool (structure Item: Item) =
   sig
      type pool
	 
      val nullPool : unit -> pool
      val makePool :  int -> pool
	 
      val hasElem     : pool * Item.item -> bool
      val insertElem  : pool * Item.item -> bool
      val remElem     : pool * Item.item -> unit
      val countInsert : pool -> int
	 
      val toList : pool -> Item.item list
      val fromList : Item.item list -> pool
      val copyPool : pool -> pool
      val resetPool : pool -> unit 

      val printPool : pool -> unit 
   end

