structure StringItem =

struct
   type item 	  = string

   fun eq (x,y)   = (x = y)
   fun toString s = s
   fun toWord s   = let 
       val list = String.explode s
       fun doit ([], hash) = hash
	|  doit (c::cs, hash) = doit (cs,
		 Word.fromInt (ord c) + 0wx1f * hash)
       in  doit (list, 0wx7)
       end
end

