funsig Table (structure Item: Item
	      type value) =
   sig
      type table
	 
      val nullTable : unit -> table
      val makeTable : int ->  table
      val resetTable: table * int -> unit
	 
      val hasValue  : table * Item.item -> bool
      val update    : (table * Item.item * value) -> unit
      val add       : (table * Item.item * value) -> unit
      val sub       : table * Item.item -> value option
      val remItem   : table * Item.item -> unit

      val fromList  : (Item.item * value) list -> table
      val toList    : table -> (Item.item * value) list
      val copyTable : table -> table
      val modifyTable : (value -> value) -> table -> unit
      val modifyiTable : (Item.item * value -> value) -> table -> unit

      val max	    : table -> int
      val zeroFraction   : table -> real
      val average   : table -> real

      val printTable : (value -> string) -> table -> unit 
   end

