funsig ListTable (structure Item: Item) =
   sig
      type 'a table
	 
      val nullTable :  unit -> 'a table
      val makeTable : int -> 'a table
      val resetTable : 'a table * int -> 'a table
	 
      val hasValue  : 'a table * Item.item -> bool
      val update    : ('a table * Item.item * 'a list) -> bool
      val add       : ('a table * Item.item * 'a) -> unit
      val sub       : 'a table * Item.item -> 'a list
      val extract   : 'a table * Item.item -> 'a option
      val remItem   : 'a table * Item.item -> unit

      val fromList  : (Item.item * 'a) list -> 'a table
      val toList    : 'a table -> (Item.item * 'a list) list
      val copyTable : 'a table -> 'a table
	 
      val max	    : 'a table -> int
      val zeroFraction   : 'a table -> real
      val average   : 'a table -> real

      val printTable : ('a -> string) -> 'a table -> unit 
   end

