functor Pair (structure First:Item
	      structure Second:Item) : Item =

struct
   type item = First.item * Second.item

   fun toString (a,b) = (First.toString a)^"/"^(Second.toString b)
(*
   fun toString (a,b) = "("^(First.toString a)^
		        ","^(Second.toString b)^")"
*)
   fun toWord (a,b) = ((First.toWord a) + 0wx7)* 0wx7ff +
		      (Second.toWord b) 

(*********************************************************************)
(* the following function is way too inefficient ...		     *)
(*								     *)
(* fun toWord (a,b) = (((First.toWord a) + 0wx7)* (0wxd3 +
		      (Second.toWord b))) div 0wxd3
								     *)
(*********************************************************************)

end

structure IntPairItem : Item =
   Pair (structure First = IntItem
	 structure Second = IntItem)

structure StringIntItem : Item =
   Pair (structure First = StringItem
	 structure Second = IntItem)
