funsig SymbolTable (structure Item : Item) =

sig
   type table

   val makeTable  :	int  -> table
   val nullTable  :	unit -> table

   val getIndex   :	table * Item.item -> int
   val getItem    :	table * int -> Item.item
   val addItem    :	table * Item.item -> int
   val remItem    :	table * Item.item -> unit
   val hasIndex   :	table * Item.item -> bool
   val isEmpty    :     table -> bool             (* by sun 22 Oct *)
   val numberOfItems :	table -> int

   val toString	  :	table -> string
end
