structure Tail =

struct
   fun app f [] 	= ()
    |  app f [a] 	= f a
    |  app f (a::aa)	= (f a; app f aa)

   fun foldl f b []	= b
    |  foldl f b [a]	= f (a,b)
    |  foldl f b (a::aa)= foldl f (f (a,b)) aa

   fun foldli f b (list,i,cond) = case cond
	of SOME n => if i >= n then b
		else let
		fun doit2 (j,[],b) = b
		 |  doit2 (j,[a],b) = if j >= n then b
			else f (j,a,b)
		 |  doit2 (j,a::aa,b) = if j = n-1 then f (j,a,b)
			else doit2 (j+1,aa,f (j,a,b))
		fun doit1 (j,[]) = b
		 |  doit1 (j,aa) = if j < i then doit1 (j+1,tl aa)
			else doit2 (j, aa,b)
	 	in doit1 (0,list)
		end
	 | NONE => let
		fun doit2 (j,[],b) = b
                 |  doit2 (j,[a],b) = f (j,a,b)
                 |  doit2 (j,a::aa,b) = doit2 (j+1,aa,f (j,a,b))
                fun doit1 (j,[]) = b
                 |  doit1 (j,aa) = if j < i then doit1 (j+1,tl aa)
                        else doit2 (j, aa, b)
                in doit1 (0,list)
                end

   fun foldri f b (list,i,cond) = case cond
	of SOME n => if i >= n then b
                else let
                fun doit2 (j,[],b) = b
		 |  doit2 (j,a::aa,b) = if j = n-1 then f (j,a,b)
			else f (j,a, doit2 (j+1,aa,b))
		fun doit1 (j,[]) = b
                 |  doit1 (j,aa) = if j < i then doit1 (j+1,tl aa)
                        else doit2 (j, aa,b)
                in doit1 (0,list)
                end
	| NONE => let
                fun doit2 (j,[],b) = b
                 |  doit2 (j,a::aa,b) = f (j,a, doit2 (j+1,aa,b))
                fun doit1 (j,[]) = b
                 |  doit1 (j,aa) = if j < i then doit1 (j+1,tl aa)
                        else doit2 (j, aa, b)
                in doit1 (0,list)
                end

   fun mapi f (list,i,cond) = case cond
	of SOME n => if i >= n then []
		else let
		fun doit2 (j,[]) = []
		 |  doit2 (j,a::aa) = if j >= n then []
			else f (j,a) :: doit2 (j+1,aa)
		fun doit1 (j,[]) = []
		 |  doit1 (j,aa) = if j < i then doit1 (j+1,tl aa)
			else doit2 (j,aa)
		in doit1 (0,list)
		end
	|  NONE => let
		fun doit2 (j,[]) = []
                 |  doit2 (j,a::aa) = f (j,a) :: doit2 (j+1,aa)
                fun doit1 (j,[]) = []
                 |  doit1 (j,aa) = if j < i then doit1 (j+1,tl aa)
                        else doit2 (j,aa)
		in doit1 (0,list)
		end

	
    
   fun appTest n = let
	fun doit k = if k >= n then print "\n\n\tReady :-)"
		     else app doit [k+1]
	in doit 0
	end

   fun appTestL n = let
	fun doit k = if k >= n then print "\n\n\tReady :-)"
		     else List.app doit [k+1]
	in doit 0
	end

   fun foldTest n = let
	fun f (k,acc) = if k >= n then print "\n\n\tReady :-)\n"
		     else foldl f acc [k+1]
	in f (0,())
	end

   fun foldTestL n = let
	fun f (k,acc) = if k >= n then print "\n\n\tReady :-)\n"
		     else List.foldl f acc [k+1]
	in f (0,())
	end

end
